Index: trunk/sources/HeuristicLab.Optimization.Views/3.3/RunView.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization.Views/3.3/RunView.Designer.cs	(revision 3300)
+++ trunk/sources/HeuristicLab.Optimization.Views/3.3/RunView.Designer.cs	(revision 3638)
@@ -46,6 +46,6 @@
     private void InitializeComponent() {
       this.components = new System.ComponentModel.Container();
-      System.Windows.Forms.ListViewGroup listViewGroup1 = new System.Windows.Forms.ListViewGroup("Results", System.Windows.Forms.HorizontalAlignment.Left);
-      System.Windows.Forms.ListViewGroup listViewGroup2 = new System.Windows.Forms.ListViewGroup("Parameters", System.Windows.Forms.HorizontalAlignment.Left);
+      System.Windows.Forms.ListViewGroup listViewGroup3 = new System.Windows.Forms.ListViewGroup("Results", System.Windows.Forms.HorizontalAlignment.Left);
+      System.Windows.Forms.ListViewGroup listViewGroup4 = new System.Windows.Forms.ListViewGroup("Parameters", System.Windows.Forms.HorizontalAlignment.Left);
       this.parametersResultsGroupBox = new System.Windows.Forms.GroupBox();
       this.splitContainer = new System.Windows.Forms.SplitContainer();
@@ -57,4 +57,8 @@
       this.viewHost = new HeuristicLab.MainForm.WindowsForms.ViewHost();
       this.showAlgorithmButton = new System.Windows.Forms.Button();
+      this.changeColorButton = new System.Windows.Forms.Button();
+      this.colorLabel = new System.Windows.Forms.Label();
+      this.colorPictureBox = new System.Windows.Forms.PictureBox();
+      this.colorDialog = new System.Windows.Forms.ColorDialog();
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
       this.parametersResultsGroupBox.SuspendLayout();
@@ -63,4 +67,5 @@
       this.splitContainer.SuspendLayout();
       this.detailsGroupBox.SuspendLayout();
+      ((System.ComponentModel.ISupportInitialize)(this.colorPictureBox)).BeginInit();
       this.SuspendLayout();
       // 
@@ -81,7 +86,7 @@
                   | System.Windows.Forms.AnchorStyles.Right)));
       this.parametersResultsGroupBox.Controls.Add(this.splitContainer);
-      this.parametersResultsGroupBox.Location = new System.Drawing.Point(0, 52);
+      this.parametersResultsGroupBox.Location = new System.Drawing.Point(0, 79);
       this.parametersResultsGroupBox.Name = "parametersResultsGroupBox";
-      this.parametersResultsGroupBox.Size = new System.Drawing.Size(495, 272);
+      this.parametersResultsGroupBox.Size = new System.Drawing.Size(495, 245);
       this.parametersResultsGroupBox.TabIndex = 4;
       this.parametersResultsGroupBox.TabStop = false;
@@ -101,5 +106,5 @@
       // 
       this.splitContainer.Panel2.Controls.Add(this.detailsGroupBox);
-      this.splitContainer.Size = new System.Drawing.Size(489, 253);
+      this.splitContainer.Size = new System.Drawing.Size(489, 226);
       this.splitContainer.SplitterDistance = 177;
       this.splitContainer.TabIndex = 0;
@@ -114,11 +119,11 @@
             this.valueColumnHeader});
       this.listView.FullRowSelect = true;
-      listViewGroup1.Header = "Results";
-      listViewGroup1.Name = "resultsGroup";
-      listViewGroup2.Header = "Parameters";
-      listViewGroup2.Name = "parametersGroup";
+      listViewGroup3.Header = "Results";
+      listViewGroup3.Name = "resultsGroup";
+      listViewGroup4.Header = "Parameters";
+      listViewGroup4.Name = "parametersGroup";
       this.listView.Groups.AddRange(new System.Windows.Forms.ListViewGroup[] {
-            listViewGroup1,
-            listViewGroup2});
+            listViewGroup3,
+            listViewGroup4});
       this.listView.HideSelection = false;
       this.listView.Location = new System.Drawing.Point(3, 3);
@@ -126,5 +131,5 @@
       this.listView.Name = "listView";
       this.listView.ShowItemToolTips = true;
-      this.listView.Size = new System.Drawing.Size(171, 247);
+      this.listView.Size = new System.Drawing.Size(171, 220);
       this.listView.SmallImageList = this.imageList;
       this.listView.Sorting = System.Windows.Forms.SortOrder.Ascending;
@@ -158,5 +163,5 @@
       this.detailsGroupBox.Location = new System.Drawing.Point(3, 3);
       this.detailsGroupBox.Name = "detailsGroupBox";
-      this.detailsGroupBox.Size = new System.Drawing.Size(302, 247);
+      this.detailsGroupBox.Size = new System.Drawing.Size(302, 220);
       this.detailsGroupBox.TabIndex = 0;
       this.detailsGroupBox.TabStop = false;
@@ -168,8 +173,10 @@
                   | System.Windows.Forms.AnchorStyles.Left)
                   | System.Windows.Forms.AnchorStyles.Right)));
+      this.viewHost.Caption = null;
       this.viewHost.Content = null;
       this.viewHost.Location = new System.Drawing.Point(6, 19);
       this.viewHost.Name = "viewHost";
-      this.viewHost.Size = new System.Drawing.Size(290, 222);
+      this.viewHost.ReadOnly = false;
+      this.viewHost.Size = new System.Drawing.Size(290, 195);
       this.viewHost.TabIndex = 0;
       this.viewHost.ViewType = null;
@@ -188,8 +195,40 @@
       this.showAlgorithmButton.Click += new System.EventHandler(this.showAlgorithmButton_Click);
       // 
+      // changeColorButton
+      // 
+      this.changeColorButton.Enabled = false;
+      this.changeColorButton.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
+      this.changeColorButton.Location = new System.Drawing.Point(94, 52);
+      this.changeColorButton.Name = "changeColorButton";
+      this.changeColorButton.Size = new System.Drawing.Size(64, 21);
+      this.changeColorButton.TabIndex = 21;
+      this.changeColorButton.Text = "Change";
+      this.changeColorButton.UseVisualStyleBackColor = true;
+      this.changeColorButton.Click += new System.EventHandler(this.changeColorButton_Click);
+      // 
+      // colorLabel
+      // 
+      this.colorLabel.AutoSize = true;
+      this.colorLabel.Location = new System.Drawing.Point(3, 56);
+      this.colorLabel.Name = "colorLabel";
+      this.colorLabel.Size = new System.Drawing.Size(34, 13);
+      this.colorLabel.TabIndex = 22;
+      this.colorLabel.Text = "Color:";
+      // 
+      // colorPictureBox
+      // 
+      this.colorPictureBox.Location = new System.Drawing.Point(73, 54);
+      this.colorPictureBox.Name = "colorPictureBox";
+      this.colorPictureBox.Size = new System.Drawing.Size(17, 17);
+      this.colorPictureBox.TabIndex = 23;
+      this.colorPictureBox.TabStop = false;
+      // 
       // RunView
       // 
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.colorPictureBox);
+      this.Controls.Add(this.colorLabel);
+      this.Controls.Add(this.changeColorButton);
       this.Controls.Add(this.parametersResultsGroupBox);
       this.Controls.Add(this.showAlgorithmButton);
@@ -202,4 +241,7 @@
       this.Controls.SetChildIndex(this.nameTextBox, 0);
       this.Controls.SetChildIndex(this.nameLabel, 0);
+      this.Controls.SetChildIndex(this.changeColorButton, 0);
+      this.Controls.SetChildIndex(this.colorLabel, 0);
+      this.Controls.SetChildIndex(this.colorPictureBox, 0);
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
       this.parametersResultsGroupBox.ResumeLayout(false);
@@ -208,4 +250,5 @@
       this.splitContainer.ResumeLayout(false);
       this.detailsGroupBox.ResumeLayout(false);
+      ((System.ComponentModel.ISupportInitialize)(this.colorPictureBox)).EndInit();
       this.ResumeLayout(false);
       this.PerformLayout();
@@ -224,4 +267,8 @@
     private System.Windows.Forms.ImageList imageList;
     private System.Windows.Forms.Button showAlgorithmButton;
+    private System.Windows.Forms.Label colorLabel;
+    private System.Windows.Forms.Button changeColorButton;
+    private System.Windows.Forms.PictureBox colorPictureBox;
+    private System.Windows.Forms.ColorDialog colorDialog;
 
   }